# QMake Build file
BDDFLAGS = $$system(gcc ../BFAbstractionLibrary/compilerOptionGenerator.c -o /tmp/BFAbstractionCompilerOptionsProducer-$$(USER);/tmp/BFAbstractionCompilerOptionsProducer-$$(USER))
DEFINES += USE_CUDD NDEBUG
CFLAGS += -g
QMAKE_CFLAGS_RELEASE += -g $$system(xml2-config --cflags)\
    $$BDDFLAGS
QMAKE_CXXFLAGS_RELEASE += -g -std=gnu++0x $$system(xml2-config --cflags) \
    $$BDDFLAGS
QMAKE_CFLAGS_DEBUG += -g $$system(xml2-config --cflags)\
    $$BDDFLAGS
QMAKE_CXXFLAGS_DEBUG += -g -std=gnu++0x $$system(xml2-config --cflags)\
    $$BDDFLAGS

TEMPLATE = app \
    console
CONFIG += release
CONFIG -= qt
HEADERS += UVW.h \
    ../BFAbstractionLibrary/bddDump.h \
    ../BFAbstractionLibrary/BF.h \
    ../BFAbstractionLibrary/BFCudd.h \
    ../BFAbstractionLibrary/BFCuddManager.h \
    ../BFAbstractionLibrary/BFCuddInlines.h \
    ../BFAbstractionLibrary/BFCuddVarVector.h \
    variableAllocationOptimizer.hpp \
    advancedVariableInfoContainer.hpp

SOURCES += main.cpp \
    ../BFAbstractionLibrary/BFCudd.cpp \
    ../BFAbstractionLibrary/BFCuddManager.cpp \
    ../BFAbstractionLibrary/BFCuddVarCube.cpp  \
    ../BFAbstractionLibrary/BFCuddVarVector.cpp  \
    ../BFAbstractionLibrary/bddDump.cpp \
    variableAllocationOptimizer.cpp

TARGET = backend
INCLUDEPATH = ../BFAbstractionLibrary ../cudd-2.4.2/include

LIBS += -L../cudd-2.4.2/cudd \
    -L../cudd-2.4.2/dddmp \
    -L../cudd-2.4.2/epd \
    -L../cudd-2.4.2/mtr \
    -L../cudd-2.4.2/sis \
    -L../cudd-2.4.2/st \
    -L../cudd-2.4.2/util \
    -ldddmp \
    -lcudd \
    -lepd \
    -lmtr \
    -lst \
    -lutil \
    $$system(xml2-config --libs)


PKGCONFIG += 
QT -= gui \
    core
