/*
 * BFHelper.h
 *
 *  Created on: 12.10.2010
 *      Author: ehlers
 */

#ifndef BFHELPER_H_
#define BFHELPER_H_

#include <vector>

#include "BF.h"

class BFHelper {
private:
	const BFManager& m_manager;

	BF bitStringLess(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> bitStringAdd(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> bitStringSubtract(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> bitStringMultiply(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> bitStringDivide(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> bitStringModulo(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> bitStringSaturate(const uint nof_target_bits, std::vector<BF> a, const int min, const int max) const;

public:
	BFHelper(const BFManager& manager);

	std::vector<BF> bitSelect(const BF selector, const std::vector<BF>& a, const std::vector<BF>& b) const;
	BF bitStringEquals(const std::vector<BF>& a, const std::vector<BF>& b) const;

	BF signedBitStringLess(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> signedBitStringAdd(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> signedBitStringSubtract(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> signedBitStringMultiply(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> signedBitStringDivide(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> signedBitStringModulo(const std::vector<BF>& a, const std::vector<BF>& b) const;
	std::vector<BF> signedBitStringSaturate(const uint nof_target_bits, std::vector<BF> a, const int min, const int max) const;


};

#endif /* BFHELPER_H_ */
