/*
 * BFStateToVariableValuationEncoderClassicAutobit.h
 *
 *  Created on: 17.08.2010
 *      Author: ehlers
 */

#ifndef BFSTATETOVARIABLEVALUATIONENCODERCLASSICAUTOBIT_H_
#define BFSTATETOVARIABLEVALUATIONENCODERCLASSICAUTOBIT_H_

#include <vector>
#include <set>
#include "BFStateToVariableValuationEncoder.h"

class BFStateToVariableValuationEncoderClassicAutobit: public BFStateToVariableValuationEncoder {
private:
	uint nofStates;
	std::vector<std::set<uint> > transitions;

	int nofBits; // set to ceil(log_2(nofStates)) in the constructor
	uint *m_assignment; // The m_assignment computed
	int *currentCosts; // Used during the computation of the assignments (deleted afterwards)
	std::vector<char*> grayCodes; // Used all the time

	int computeCostForState(uint stateNr);

public:
	BFStateToVariableValuationEncoderClassicAutobit();
	virtual ~BFStateToVariableValuationEncoderClassicAutobit();

	virtual void run();
	virtual void reset(uint numberOfStates);
	virtual void addTransition(uint from, uint to);
	virtual uint getAssignment(uint stateNr) const;
	virtual int getNumberOfBits() const;
};

#endif /* BFSTATETOVARIABLEVALUATIONENCODERCLASSICAUTOBIT_H_ */
