#! /usr/bin/env python
# LR(1) parser, autogenerated on 2011-11-13 18:56:34
# generator: wisent 0.6.1, http://seehuhn.de/pages/wisent
# source: grammar.wi

# All parts of this file which are not taken verbatim from the input grammar
# are covered by the following notice:
#
# Copyright (C) 2008, 2009  Jochen Voss <voss@seehuhn.de>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#
#   2. Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#
#   3. The name of the author may not be used to endorse or promote
#      products derived from this software without specific prior
#      written permission.
#
# This software is provided by the author "as is" and any express or
# implied warranties, including, but not limited to, the implied
# warranties of merchantability and fitness for a particular purpose
# are disclaimed.  In no event shall the author be liable for any
# direct, indirect, incidental, special, exemplary, or consequential
# damages (including, but not limited to, procurement of substitute
# goods or services; loss of use, data, or profits; or business
# interruption) however caused and on any theory of liability, whether
# in contract, strict liability, or tort (including negligence or
# otherwise) arising in any way out of the use of this software, even
# if advised of the possibility of such damage.

from itertools import chain

class Unique(object):

    """Unique objects for use as markers.

    These objects are internally used to represent the start symbol
    and the end-of-input marker of the grammar.
    """

    def __init__(self, label):
        """Create a new unique object.

        `label` is a string which is used as a textual representation
        of the object.
        """
        self.label = label

    def __repr__(self):
        """Return the `label` given at object construction."""
        return self.label

class Parser(object):

    """LR(1) parser class.

    terminal symbols:
      '!', '&', '(', ')', '*', '+', '-', '/', '0', '1', '<', '=', '>', 'F',
      'FALSE', 'G', 'TRUE', 'U', 'W', 'X', '[', '\\', ']', '^', 'id', '|', '~'

    nonterminal symbols:
      'Assignment', 'AtomicFormula', 'Biimplication', 'BiimplicationOperator',
      'BinaryTemporalFormula', 'BinaryTemporalOperator', 'Brackets',
      'Conjunction', 'ConjunctionOperator', 'Disjunction',
      'DisjunctionOperator', 'FinallyOperator', 'GloballyOperator',
      'Implication', 'ImplicationOperator', 'NextOperator', 'NotOperator',
      'UnaryFormula', 'UnaryTemporalOperator', 'UntilOperator',
      'WeakUntilOperator', 'Xor', 'XorOperator'

    production rules:
      'Biimplication' -> 'Implication'
      'Biimplication' -> 'Biimplication' 'BiimplicationOperator' 'Implication'
      'Implication' -> 'Xor'
      'Implication' -> 'Implication' 'ImplicationOperator' 'Xor'
      'Xor' -> 'Disjunction'
      'Xor' -> 'Xor' 'XorOperator' 'Disjunction'
      'Disjunction' -> 'Conjunction'
      'Disjunction' -> 'Disjunction' 'DisjunctionOperator' 'Conjunction'
      'Conjunction' -> 'BinaryTemporalFormula'
      'Conjunction' -> 'Conjunction' 'ConjunctionOperator' 'BinaryTemporalFormula'
      'BinaryTemporalFormula' -> 'UnaryFormula'
      'BinaryTemporalFormula' -> 'BinaryTemporalFormula' 'BinaryTemporalOperator' 'UnaryFormula'
      'UnaryFormula' -> 'AtomicFormula'
      'UnaryFormula' -> 'UnaryTemporalOperator' 'UnaryFormula'
      'AtomicFormula' -> 'FALSE'
      'AtomicFormula' -> 'TRUE'
      'AtomicFormula' -> 'Brackets'
      'AtomicFormula' -> 'Assignment'
      'Brackets' -> '(' 'Biimplication' ')'
      'BinaryTemporalOperator' -> 'UntilOperator'
      'BinaryTemporalOperator' -> 'WeakUntilOperator'
      'UntilOperator' -> 'U'
      'WeakUntilOperator' -> 'W'
      'ImplicationOperator' -> '-' '-' '>'
      'ImplicationOperator' -> '-' '>'
      'BiimplicationOperator' -> '<' '-' '-' '>'
      'BiimplicationOperator' -> '<' '-' '>'
      'DisjunctionOperator' -> '+'
      'DisjunctionOperator' -> '\\' '/'
      'DisjunctionOperator' -> '|'
      'DisjunctionOperator' -> '|' '|'
      'ConjunctionOperator' -> '*'
      'ConjunctionOperator' -> '/' '\\'
      'ConjunctionOperator' -> '&'
      'ConjunctionOperator' -> '&' '&'
      'XorOperator' -> '^'
      'UnaryTemporalOperator' -> 'FinallyOperator'
      'UnaryTemporalOperator' -> 'NextOperator'
      'UnaryTemporalOperator' -> 'GloballyOperator'
      'UnaryTemporalOperator' -> 'NotOperator'
      'FinallyOperator' -> '<' '>'
      'FinallyOperator' -> 'F'
      'NextOperator' -> '(' ')'
      'NextOperator' -> 'X'
      'GloballyOperator' -> '[' ']'
      'GloballyOperator' -> 'G'
      'NotOperator' -> '!'
      'NotOperator' -> '~'
      'Assignment' -> 'id'
      'Assignment' -> 'id' '=' '0'
      'Assignment' -> 'id' '=' '1'
    """

    class ParseErrors(Exception):

        """Exception class to represent a collection of parse errors.

        Instances of this class have two attributes, `errors` and `tree`.
        `errors` is a list of tuples, each describing one error.
        Each tuple consists of the first input token which could not
        be processed and the list of grammar symbols which were allowed
        at this point.
        `tree` is a "repaired" parse tree which might be used for further
        error checking, or `None` if no repair was possible.
        """

        def __init__(self, errors, tree):
            msg = "%d parse errors"%len(errors)
            Exception.__init__(self, msg)
            self.errors = errors
            self.tree = tree

    terminals = [ '!', '&', '(', ')', '*', '+', '-', '/', '0', '1', '<', '=',
                  '>', 'F', 'FALSE', 'G', 'TRUE', 'U', 'W', 'X', '[', '\\',
                  ']', '^', 'id', '|', '~' ]
    EOF = Unique('EOF')
    S = Unique('S')

    _halting_state = 72
    _reduce = {
        (2, EOF): ('Biimplication', 1), (2, ')'): ('Biimplication', 1),
        (2, '<'): ('Biimplication', 1), (5, EOF): ('Biimplication', 3),
        (5, ')'): ('Biimplication', 3), (5, '<'): ('Biimplication', 3),
        (6, EOF): ('Implication', 1), (6, ')'): ('Implication', 1),
        (6, '-'): ('Implication', 1), (6, '<'): ('Implication', 1),
        (8, EOF): ('Implication', 3), (8, ')'): ('Implication', 3),
        (8, '-'): ('Implication', 3), (8, '<'): ('Implication', 3),
        (9, EOF): ('Xor', 1), (9, ')'): ('Xor', 1), (9, '-'): ('Xor', 1),
        (9, '<'): ('Xor', 1), (9, '^'): ('Xor', 1), (11, EOF): ('Xor', 3),
        (11, ')'): ('Xor', 3), (11, '-'): ('Xor', 3), (11, '<'): ('Xor', 3),
        (11, '^'): ('Xor', 3), (12, EOF): ('Disjunction', 1),
        (12, ')'): ('Disjunction', 1), (12, '+'): ('Disjunction', 1),
        (12, '-'): ('Disjunction', 1), (12, '<'): ('Disjunction', 1),
        (12, '\\'): ('Disjunction', 1), (12, '^'): ('Disjunction', 1),
        (12, '|'): ('Disjunction', 1), (14, EOF): ('Disjunction', 3),
        (14, ')'): ('Disjunction', 3), (14, '+'): ('Disjunction', 3),
        (14, '-'): ('Disjunction', 3), (14, '<'): ('Disjunction', 3),
        (14, '\\'): ('Disjunction', 3), (14, '^'): ('Disjunction', 3),
        (14, '|'): ('Disjunction', 3), (15, EOF): ('Conjunction', 1),
        (15, '&'): ('Conjunction', 1), (15, ')'): ('Conjunction', 1),
        (15, '*'): ('Conjunction', 1), (15, '+'): ('Conjunction', 1),
        (15, '-'): ('Conjunction', 1), (15, '/'): ('Conjunction', 1),
        (15, '<'): ('Conjunction', 1), (15, '\\'): ('Conjunction', 1),
        (15, '^'): ('Conjunction', 1), (15, '|'): ('Conjunction', 1),
        (17, EOF): ('Conjunction', 3), (17, '&'): ('Conjunction', 3),
        (17, ')'): ('Conjunction', 3), (17, '*'): ('Conjunction', 3),
        (17, '+'): ('Conjunction', 3), (17, '-'): ('Conjunction', 3),
        (17, '/'): ('Conjunction', 3), (17, '<'): ('Conjunction', 3),
        (17, '\\'): ('Conjunction', 3), (17, '^'): ('Conjunction', 3),
        (17, '|'): ('Conjunction', 3), (18, EOF): ('BinaryTemporalFormula', 1),
        (18, '&'): ('BinaryTemporalFormula', 1),
        (18, ')'): ('BinaryTemporalFormula', 1),
        (18, '*'): ('BinaryTemporalFormula', 1),
        (18, '+'): ('BinaryTemporalFormula', 1),
        (18, '-'): ('BinaryTemporalFormula', 1),
        (18, '/'): ('BinaryTemporalFormula', 1),
        (18, '<'): ('BinaryTemporalFormula', 1),
        (18, 'U'): ('BinaryTemporalFormula', 1),
        (18, 'W'): ('BinaryTemporalFormula', 1),
        (18, '\\'): ('BinaryTemporalFormula', 1),
        (18, '^'): ('BinaryTemporalFormula', 1),
        (18, '|'): ('BinaryTemporalFormula', 1),
        (20, EOF): ('BinaryTemporalFormula', 3),
        (20, '&'): ('BinaryTemporalFormula', 3),
        (20, ')'): ('BinaryTemporalFormula', 3),
        (20, '*'): ('BinaryTemporalFormula', 3),
        (20, '+'): ('BinaryTemporalFormula', 3),
        (20, '-'): ('BinaryTemporalFormula', 3),
        (20, '/'): ('BinaryTemporalFormula', 3),
        (20, '<'): ('BinaryTemporalFormula', 3),
        (20, 'U'): ('BinaryTemporalFormula', 3),
        (20, 'W'): ('BinaryTemporalFormula', 3),
        (20, '\\'): ('BinaryTemporalFormula', 3),
        (20, '^'): ('BinaryTemporalFormula', 3),
        (20, '|'): ('BinaryTemporalFormula', 3),
        (21, EOF): ('UnaryFormula', 1), (21, '&'): ('UnaryFormula', 1),
        (21, ')'): ('UnaryFormula', 1), (21, '*'): ('UnaryFormula', 1),
        (21, '+'): ('UnaryFormula', 1), (21, '-'): ('UnaryFormula', 1),
        (21, '/'): ('UnaryFormula', 1), (21, '<'): ('UnaryFormula', 1),
        (21, 'U'): ('UnaryFormula', 1), (21, 'W'): ('UnaryFormula', 1),
        (21, '\\'): ('UnaryFormula', 1), (21, '^'): ('UnaryFormula', 1),
        (21, '|'): ('UnaryFormula', 1), (23, EOF): ('UnaryFormula', 2),
        (23, '&'): ('UnaryFormula', 2), (23, ')'): ('UnaryFormula', 2),
        (23, '*'): ('UnaryFormula', 2), (23, '+'): ('UnaryFormula', 2),
        (23, '-'): ('UnaryFormula', 2), (23, '/'): ('UnaryFormula', 2),
        (23, '<'): ('UnaryFormula', 2), (23, 'U'): ('UnaryFormula', 2),
        (23, 'W'): ('UnaryFormula', 2), (23, '\\'): ('UnaryFormula', 2),
        (23, '^'): ('UnaryFormula', 2), (23, '|'): ('UnaryFormula', 2),
        (24, EOF): ('AtomicFormula', 1), (24, '&'): ('AtomicFormula', 1),
        (24, ')'): ('AtomicFormula', 1), (24, '*'): ('AtomicFormula', 1),
        (24, '+'): ('AtomicFormula', 1), (24, '-'): ('AtomicFormula', 1),
        (24, '/'): ('AtomicFormula', 1), (24, '<'): ('AtomicFormula', 1),
        (24, 'U'): ('AtomicFormula', 1), (24, 'W'): ('AtomicFormula', 1),
        (24, '\\'): ('AtomicFormula', 1), (24, '^'): ('AtomicFormula', 1),
        (24, '|'): ('AtomicFormula', 1), (25, EOF): ('AtomicFormula', 1),
        (25, '&'): ('AtomicFormula', 1), (25, ')'): ('AtomicFormula', 1),
        (25, '*'): ('AtomicFormula', 1), (25, '+'): ('AtomicFormula', 1),
        (25, '-'): ('AtomicFormula', 1), (25, '/'): ('AtomicFormula', 1),
        (25, '<'): ('AtomicFormula', 1), (25, 'U'): ('AtomicFormula', 1),
        (25, 'W'): ('AtomicFormula', 1), (25, '\\'): ('AtomicFormula', 1),
        (25, '^'): ('AtomicFormula', 1), (25, '|'): ('AtomicFormula', 1),
        (26, EOF): ('AtomicFormula', 1), (26, '&'): ('AtomicFormula', 1),
        (26, ')'): ('AtomicFormula', 1), (26, '*'): ('AtomicFormula', 1),
        (26, '+'): ('AtomicFormula', 1), (26, '-'): ('AtomicFormula', 1),
        (26, '/'): ('AtomicFormula', 1), (26, '<'): ('AtomicFormula', 1),
        (26, 'U'): ('AtomicFormula', 1), (26, 'W'): ('AtomicFormula', 1),
        (26, '\\'): ('AtomicFormula', 1), (26, '^'): ('AtomicFormula', 1),
        (26, '|'): ('AtomicFormula', 1), (27, EOF): ('AtomicFormula', 1),
        (27, '&'): ('AtomicFormula', 1), (27, ')'): ('AtomicFormula', 1),
        (27, '*'): ('AtomicFormula', 1), (27, '+'): ('AtomicFormula', 1),
        (27, '-'): ('AtomicFormula', 1), (27, '/'): ('AtomicFormula', 1),
        (27, '<'): ('AtomicFormula', 1), (27, 'U'): ('AtomicFormula', 1),
        (27, 'W'): ('AtomicFormula', 1), (27, '\\'): ('AtomicFormula', 1),
        (27, '^'): ('AtomicFormula', 1), (27, '|'): ('AtomicFormula', 1),
        (29, EOF): ('Brackets', 3), (29, '&'): ('Brackets', 3),
        (29, ')'): ('Brackets', 3), (29, '*'): ('Brackets', 3),
        (29, '+'): ('Brackets', 3), (29, '-'): ('Brackets', 3),
        (29, '/'): ('Brackets', 3), (29, '<'): ('Brackets', 3),
        (29, 'U'): ('Brackets', 3), (29, 'W'): ('Brackets', 3),
        (29, '\\'): ('Brackets', 3), (29, '^'): ('Brackets', 3),
        (29, '|'): ('Brackets', 3), (30, '!'): ('BinaryTemporalOperator', 1),
        (30, '('): ('BinaryTemporalOperator', 1),
        (30, '<'): ('BinaryTemporalOperator', 1),
        (30, 'F'): ('BinaryTemporalOperator', 1),
        (30, 'FALSE'): ('BinaryTemporalOperator', 1),
        (30, 'G'): ('BinaryTemporalOperator', 1),
        (30, 'TRUE'): ('BinaryTemporalOperator', 1),
        (30, 'X'): ('BinaryTemporalOperator', 1),
        (30, '['): ('BinaryTemporalOperator', 1),
        (30, 'id'): ('BinaryTemporalOperator', 1),
        (30, '~'): ('BinaryTemporalOperator', 1),
        (31, '!'): ('BinaryTemporalOperator', 1),
        (31, '('): ('BinaryTemporalOperator', 1),
        (31, '<'): ('BinaryTemporalOperator', 1),
        (31, 'F'): ('BinaryTemporalOperator', 1),
        (31, 'FALSE'): ('BinaryTemporalOperator', 1),
        (31, 'G'): ('BinaryTemporalOperator', 1),
        (31, 'TRUE'): ('BinaryTemporalOperator', 1),
        (31, 'X'): ('BinaryTemporalOperator', 1),
        (31, '['): ('BinaryTemporalOperator', 1),
        (31, 'id'): ('BinaryTemporalOperator', 1),
        (31, '~'): ('BinaryTemporalOperator', 1),
        (32, '!'): ('UntilOperator', 1), (32, '('): ('UntilOperator', 1),
        (32, '<'): ('UntilOperator', 1), (32, 'F'): ('UntilOperator', 1),
        (32, 'FALSE'): ('UntilOperator', 1), (32, 'G'): ('UntilOperator', 1),
        (32, 'TRUE'): ('UntilOperator', 1), (32, 'X'): ('UntilOperator', 1),
        (32, '['): ('UntilOperator', 1), (32, 'id'): ('UntilOperator', 1),
        (32, '~'): ('UntilOperator', 1), (33, '!'): ('WeakUntilOperator', 1),
        (33, '('): ('WeakUntilOperator', 1),
        (33, '<'): ('WeakUntilOperator', 1),
        (33, 'F'): ('WeakUntilOperator', 1),
        (33, 'FALSE'): ('WeakUntilOperator', 1),
        (33, 'G'): ('WeakUntilOperator', 1),
        (33, 'TRUE'): ('WeakUntilOperator', 1),
        (33, 'X'): ('WeakUntilOperator', 1),
        (33, '['): ('WeakUntilOperator', 1),
        (33, 'id'): ('WeakUntilOperator', 1),
        (33, '~'): ('WeakUntilOperator', 1),
        (36, '!'): ('ImplicationOperator', 3),
        (36, '('): ('ImplicationOperator', 3),
        (36, '<'): ('ImplicationOperator', 3),
        (36, 'F'): ('ImplicationOperator', 3),
        (36, 'FALSE'): ('ImplicationOperator', 3),
        (36, 'G'): ('ImplicationOperator', 3),
        (36, 'TRUE'): ('ImplicationOperator', 3),
        (36, 'X'): ('ImplicationOperator', 3),
        (36, '['): ('ImplicationOperator', 3),
        (36, 'id'): ('ImplicationOperator', 3),
        (36, '~'): ('ImplicationOperator', 3),
        (37, '!'): ('ImplicationOperator', 2),
        (37, '('): ('ImplicationOperator', 2),
        (37, '<'): ('ImplicationOperator', 2),
        (37, 'F'): ('ImplicationOperator', 2),
        (37, 'FALSE'): ('ImplicationOperator', 2),
        (37, 'G'): ('ImplicationOperator', 2),
        (37, 'TRUE'): ('ImplicationOperator', 2),
        (37, 'X'): ('ImplicationOperator', 2),
        (37, '['): ('ImplicationOperator', 2),
        (37, 'id'): ('ImplicationOperator', 2),
        (37, '~'): ('ImplicationOperator', 2),
        (41, '!'): ('BiimplicationOperator', 4),
        (41, '('): ('BiimplicationOperator', 4),
        (41, '<'): ('BiimplicationOperator', 4),
        (41, 'F'): ('BiimplicationOperator', 4),
        (41, 'FALSE'): ('BiimplicationOperator', 4),
        (41, 'G'): ('BiimplicationOperator', 4),
        (41, 'TRUE'): ('BiimplicationOperator', 4),
        (41, 'X'): ('BiimplicationOperator', 4),
        (41, '['): ('BiimplicationOperator', 4),
        (41, 'id'): ('BiimplicationOperator', 4),
        (41, '~'): ('BiimplicationOperator', 4),
        (42, '!'): ('BiimplicationOperator', 3),
        (42, '('): ('BiimplicationOperator', 3),
        (42, '<'): ('BiimplicationOperator', 3),
        (42, 'F'): ('BiimplicationOperator', 3),
        (42, 'FALSE'): ('BiimplicationOperator', 3),
        (42, 'G'): ('BiimplicationOperator', 3),
        (42, 'TRUE'): ('BiimplicationOperator', 3),
        (42, 'X'): ('BiimplicationOperator', 3),
        (42, '['): ('BiimplicationOperator', 3),
        (42, 'id'): ('BiimplicationOperator', 3),
        (42, '~'): ('BiimplicationOperator', 3),
        (43, '!'): ('DisjunctionOperator', 1),
        (43, '('): ('DisjunctionOperator', 1),
        (43, '<'): ('DisjunctionOperator', 1),
        (43, 'F'): ('DisjunctionOperator', 1),
        (43, 'FALSE'): ('DisjunctionOperator', 1),
        (43, 'G'): ('DisjunctionOperator', 1),
        (43, 'TRUE'): ('DisjunctionOperator', 1),
        (43, 'X'): ('DisjunctionOperator', 1),
        (43, '['): ('DisjunctionOperator', 1),
        (43, 'id'): ('DisjunctionOperator', 1),
        (43, '~'): ('DisjunctionOperator', 1),
        (45, '!'): ('DisjunctionOperator', 2),
        (45, '('): ('DisjunctionOperator', 2),
        (45, '<'): ('DisjunctionOperator', 2),
        (45, 'F'): ('DisjunctionOperator', 2),
        (45, 'FALSE'): ('DisjunctionOperator', 2),
        (45, 'G'): ('DisjunctionOperator', 2),
        (45, 'TRUE'): ('DisjunctionOperator', 2),
        (45, 'X'): ('DisjunctionOperator', 2),
        (45, '['): ('DisjunctionOperator', 2),
        (45, 'id'): ('DisjunctionOperator', 2),
        (45, '~'): ('DisjunctionOperator', 2),
        (46, '!'): ('DisjunctionOperator', 1),
        (46, '('): ('DisjunctionOperator', 1),
        (46, '<'): ('DisjunctionOperator', 1),
        (46, 'F'): ('DisjunctionOperator', 1),
        (46, 'FALSE'): ('DisjunctionOperator', 1),
        (46, 'G'): ('DisjunctionOperator', 1),
        (46, 'TRUE'): ('DisjunctionOperator', 1),
        (46, 'X'): ('DisjunctionOperator', 1),
        (46, '['): ('DisjunctionOperator', 1),
        (46, 'id'): ('DisjunctionOperator', 1),
        (46, '~'): ('DisjunctionOperator', 1),
        (47, '!'): ('DisjunctionOperator', 2),
        (47, '('): ('DisjunctionOperator', 2),
        (47, '<'): ('DisjunctionOperator', 2),
        (47, 'F'): ('DisjunctionOperator', 2),
        (47, 'FALSE'): ('DisjunctionOperator', 2),
        (47, 'G'): ('DisjunctionOperator', 2),
        (47, 'TRUE'): ('DisjunctionOperator', 2),
        (47, 'X'): ('DisjunctionOperator', 2),
        (47, '['): ('DisjunctionOperator', 2),
        (47, 'id'): ('DisjunctionOperator', 2),
        (47, '~'): ('DisjunctionOperator', 2),
        (48, '!'): ('ConjunctionOperator', 1),
        (48, '('): ('ConjunctionOperator', 1),
        (48, '<'): ('ConjunctionOperator', 1),
        (48, 'F'): ('ConjunctionOperator', 1),
        (48, 'FALSE'): ('ConjunctionOperator', 1),
        (48, 'G'): ('ConjunctionOperator', 1),
        (48, 'TRUE'): ('ConjunctionOperator', 1),
        (48, 'X'): ('ConjunctionOperator', 1),
        (48, '['): ('ConjunctionOperator', 1),
        (48, 'id'): ('ConjunctionOperator', 1),
        (48, '~'): ('ConjunctionOperator', 1),
        (50, '!'): ('ConjunctionOperator', 2),
        (50, '('): ('ConjunctionOperator', 2),
        (50, '<'): ('ConjunctionOperator', 2),
        (50, 'F'): ('ConjunctionOperator', 2),
        (50, 'FALSE'): ('ConjunctionOperator', 2),
        (50, 'G'): ('ConjunctionOperator', 2),
        (50, 'TRUE'): ('ConjunctionOperator', 2),
        (50, 'X'): ('ConjunctionOperator', 2),
        (50, '['): ('ConjunctionOperator', 2),
        (50, 'id'): ('ConjunctionOperator', 2),
        (50, '~'): ('ConjunctionOperator', 2),
        (51, '!'): ('ConjunctionOperator', 1),
        (51, '('): ('ConjunctionOperator', 1),
        (51, '<'): ('ConjunctionOperator', 1),
        (51, 'F'): ('ConjunctionOperator', 1),
        (51, 'FALSE'): ('ConjunctionOperator', 1),
        (51, 'G'): ('ConjunctionOperator', 1),
        (51, 'TRUE'): ('ConjunctionOperator', 1),
        (51, 'X'): ('ConjunctionOperator', 1),
        (51, '['): ('ConjunctionOperator', 1),
        (51, 'id'): ('ConjunctionOperator', 1),
        (51, '~'): ('ConjunctionOperator', 1),
        (52, '!'): ('ConjunctionOperator', 2),
        (52, '('): ('ConjunctionOperator', 2),
        (52, '<'): ('ConjunctionOperator', 2),
        (52, 'F'): ('ConjunctionOperator', 2),
        (52, 'FALSE'): ('ConjunctionOperator', 2),
        (52, 'G'): ('ConjunctionOperator', 2),
        (52, 'TRUE'): ('ConjunctionOperator', 2),
        (52, 'X'): ('ConjunctionOperator', 2),
        (52, '['): ('ConjunctionOperator', 2),
        (52, 'id'): ('ConjunctionOperator', 2),
        (52, '~'): ('ConjunctionOperator', 2), (53, '!'): ('XorOperator', 1),
        (53, '('): ('XorOperator', 1), (53, '<'): ('XorOperator', 1),
        (53, 'F'): ('XorOperator', 1), (53, 'FALSE'): ('XorOperator', 1),
        (53, 'G'): ('XorOperator', 1), (53, 'TRUE'): ('XorOperator', 1),
        (53, 'X'): ('XorOperator', 1), (53, '['): ('XorOperator', 1),
        (53, 'id'): ('XorOperator', 1), (53, '~'): ('XorOperator', 1),
        (54, '!'): ('UnaryTemporalOperator', 1),
        (54, '('): ('UnaryTemporalOperator', 1),
        (54, '<'): ('UnaryTemporalOperator', 1),
        (54, 'F'): ('UnaryTemporalOperator', 1),
        (54, 'FALSE'): ('UnaryTemporalOperator', 1),
        (54, 'G'): ('UnaryTemporalOperator', 1),
        (54, 'TRUE'): ('UnaryTemporalOperator', 1),
        (54, 'X'): ('UnaryTemporalOperator', 1),
        (54, '['): ('UnaryTemporalOperator', 1),
        (54, 'id'): ('UnaryTemporalOperator', 1),
        (54, '~'): ('UnaryTemporalOperator', 1),
        (55, '!'): ('UnaryTemporalOperator', 1),
        (55, '('): ('UnaryTemporalOperator', 1),
        (55, '<'): ('UnaryTemporalOperator', 1),
        (55, 'F'): ('UnaryTemporalOperator', 1),
        (55, 'FALSE'): ('UnaryTemporalOperator', 1),
        (55, 'G'): ('UnaryTemporalOperator', 1),
        (55, 'TRUE'): ('UnaryTemporalOperator', 1),
        (55, 'X'): ('UnaryTemporalOperator', 1),
        (55, '['): ('UnaryTemporalOperator', 1),
        (55, 'id'): ('UnaryTemporalOperator', 1),
        (55, '~'): ('UnaryTemporalOperator', 1),
        (56, '!'): ('UnaryTemporalOperator', 1),
        (56, '('): ('UnaryTemporalOperator', 1),
        (56, '<'): ('UnaryTemporalOperator', 1),
        (56, 'F'): ('UnaryTemporalOperator', 1),
        (56, 'FALSE'): ('UnaryTemporalOperator', 1),
        (56, 'G'): ('UnaryTemporalOperator', 1),
        (56, 'TRUE'): ('UnaryTemporalOperator', 1),
        (56, 'X'): ('UnaryTemporalOperator', 1),
        (56, '['): ('UnaryTemporalOperator', 1),
        (56, 'id'): ('UnaryTemporalOperator', 1),
        (56, '~'): ('UnaryTemporalOperator', 1),
        (57, '!'): ('UnaryTemporalOperator', 1),
        (57, '('): ('UnaryTemporalOperator', 1),
        (57, '<'): ('UnaryTemporalOperator', 1),
        (57, 'F'): ('UnaryTemporalOperator', 1),
        (57, 'FALSE'): ('UnaryTemporalOperator', 1),
        (57, 'G'): ('UnaryTemporalOperator', 1),
        (57, 'TRUE'): ('UnaryTemporalOperator', 1),
        (57, 'X'): ('UnaryTemporalOperator', 1),
        (57, '['): ('UnaryTemporalOperator', 1),
        (57, 'id'): ('UnaryTemporalOperator', 1),
        (57, '~'): ('UnaryTemporalOperator', 1),
        (59, '!'): ('FinallyOperator', 2), (59, '('): ('FinallyOperator', 2),
        (59, '<'): ('FinallyOperator', 2), (59, 'F'): ('FinallyOperator', 2),
        (59, 'FALSE'): ('FinallyOperator', 2),
        (59, 'G'): ('FinallyOperator', 2),
        (59, 'TRUE'): ('FinallyOperator', 2),
        (59, 'X'): ('FinallyOperator', 2), (59, '['): ('FinallyOperator', 2),
        (59, 'id'): ('FinallyOperator', 2), (59, '~'): ('FinallyOperator', 2),
        (60, '!'): ('FinallyOperator', 1), (60, '('): ('FinallyOperator', 1),
        (60, '<'): ('FinallyOperator', 1), (60, 'F'): ('FinallyOperator', 1),
        (60, 'FALSE'): ('FinallyOperator', 1),
        (60, 'G'): ('FinallyOperator', 1),
        (60, 'TRUE'): ('FinallyOperator', 1),
        (60, 'X'): ('FinallyOperator', 1), (60, '['): ('FinallyOperator', 1),
        (60, 'id'): ('FinallyOperator', 1), (60, '~'): ('FinallyOperator', 1),
        (61, '!'): ('NextOperator', 2), (61, '('): ('NextOperator', 2),
        (61, '<'): ('NextOperator', 2), (61, 'F'): ('NextOperator', 2),
        (61, 'FALSE'): ('NextOperator', 2), (61, 'G'): ('NextOperator', 2),
        (61, 'TRUE'): ('NextOperator', 2), (61, 'X'): ('NextOperator', 2),
        (61, '['): ('NextOperator', 2), (61, 'id'): ('NextOperator', 2),
        (61, '~'): ('NextOperator', 2), (62, '!'): ('NextOperator', 1),
        (62, '('): ('NextOperator', 1), (62, '<'): ('NextOperator', 1),
        (62, 'F'): ('NextOperator', 1), (62, 'FALSE'): ('NextOperator', 1),
        (62, 'G'): ('NextOperator', 1), (62, 'TRUE'): ('NextOperator', 1),
        (62, 'X'): ('NextOperator', 1), (62, '['): ('NextOperator', 1),
        (62, 'id'): ('NextOperator', 1), (62, '~'): ('NextOperator', 1),
        (64, '!'): ('GloballyOperator', 2), (64, '('): ('GloballyOperator', 2),
        (64, '<'): ('GloballyOperator', 2), (64, 'F'): ('GloballyOperator', 2),
        (64, 'FALSE'): ('GloballyOperator', 2),
        (64, 'G'): ('GloballyOperator', 2),
        (64, 'TRUE'): ('GloballyOperator', 2),
        (64, 'X'): ('GloballyOperator', 2), (64, '['): ('GloballyOperator', 2),
        (64, 'id'): ('GloballyOperator', 2),
        (64, '~'): ('GloballyOperator', 2), (65, '!'): ('GloballyOperator', 1),
        (65, '('): ('GloballyOperator', 1), (65, '<'): ('GloballyOperator', 1),
        (65, 'F'): ('GloballyOperator', 1),
        (65, 'FALSE'): ('GloballyOperator', 1),
        (65, 'G'): ('GloballyOperator', 1),
        (65, 'TRUE'): ('GloballyOperator', 1),
        (65, 'X'): ('GloballyOperator', 1), (65, '['): ('GloballyOperator', 1),
        (65, 'id'): ('GloballyOperator', 1),
        (65, '~'): ('GloballyOperator', 1), (66, '!'): ('NotOperator', 1),
        (66, '('): ('NotOperator', 1), (66, '<'): ('NotOperator', 1),
        (66, 'F'): ('NotOperator', 1), (66, 'FALSE'): ('NotOperator', 1),
        (66, 'G'): ('NotOperator', 1), (66, 'TRUE'): ('NotOperator', 1),
        (66, 'X'): ('NotOperator', 1), (66, '['): ('NotOperator', 1),
        (66, 'id'): ('NotOperator', 1), (66, '~'): ('NotOperator', 1),
        (67, '!'): ('NotOperator', 1), (67, '('): ('NotOperator', 1),
        (67, '<'): ('NotOperator', 1), (67, 'F'): ('NotOperator', 1),
        (67, 'FALSE'): ('NotOperator', 1), (67, 'G'): ('NotOperator', 1),
        (67, 'TRUE'): ('NotOperator', 1), (67, 'X'): ('NotOperator', 1),
        (67, '['): ('NotOperator', 1), (67, 'id'): ('NotOperator', 1),
        (67, '~'): ('NotOperator', 1), (68, EOF): ('Assignment', 1),
        (68, '&'): ('Assignment', 1), (68, ')'): ('Assignment', 1),
        (68, '*'): ('Assignment', 1), (68, '+'): ('Assignment', 1),
        (68, '-'): ('Assignment', 1), (68, '/'): ('Assignment', 1),
        (68, '<'): ('Assignment', 1), (68, 'U'): ('Assignment', 1),
        (68, 'W'): ('Assignment', 1), (68, '\\'): ('Assignment', 1),
        (68, '^'): ('Assignment', 1), (68, '|'): ('Assignment', 1),
        (70, EOF): ('Assignment', 3), (70, '&'): ('Assignment', 3),
        (70, ')'): ('Assignment', 3), (70, '*'): ('Assignment', 3),
        (70, '+'): ('Assignment', 3), (70, '-'): ('Assignment', 3),
        (70, '/'): ('Assignment', 3), (70, '<'): ('Assignment', 3),
        (70, 'U'): ('Assignment', 3), (70, 'W'): ('Assignment', 3),
        (70, '\\'): ('Assignment', 3), (70, '^'): ('Assignment', 3),
        (70, '|'): ('Assignment', 3), (71, EOF): ('Assignment', 3),
        (71, '&'): ('Assignment', 3), (71, ')'): ('Assignment', 3),
        (71, '*'): ('Assignment', 3), (71, '+'): ('Assignment', 3),
        (71, '-'): ('Assignment', 3), (71, '/'): ('Assignment', 3),
        (71, '<'): ('Assignment', 3), (71, 'U'): ('Assignment', 3),
        (71, 'W'): ('Assignment', 3), (71, '\\'): ('Assignment', 3),
        (71, '^'): ('Assignment', 3), (71, '|'): ('Assignment', 3)
    }
    _goto = {
        (0, 'Assignment'): 27, (0, 'AtomicFormula'): 21,
        (0, 'Biimplication'): 1, (0, 'BinaryTemporalFormula'): 15,
        (0, 'Brackets'): 26, (0, 'Conjunction'): 12, (0, 'Disjunction'): 9,
        (0, 'FinallyOperator'): 54, (0, 'GloballyOperator'): 56,
        (0, 'Implication'): 2, (0, 'NextOperator'): 55, (0, 'NotOperator'): 57,
        (0, 'UnaryFormula'): 18, (0, 'UnaryTemporalOperator'): 22,
        (0, 'Xor'): 6, (1, 'BiimplicationOperator'): 4,
        (2, 'ImplicationOperator'): 7, (3, 'BiimplicationOperator'): 4,
        (4, 'Assignment'): 27, (4, 'AtomicFormula'): 21,
        (4, 'BinaryTemporalFormula'): 15, (4, 'Brackets'): 26,
        (4, 'Conjunction'): 12, (4, 'Disjunction'): 9,
        (4, 'FinallyOperator'): 54, (4, 'GloballyOperator'): 56,
        (4, 'Implication'): 5, (4, 'NextOperator'): 55, (4, 'NotOperator'): 57,
        (4, 'UnaryFormula'): 18, (4, 'UnaryTemporalOperator'): 22,
        (4, 'Xor'): 6, (5, 'ImplicationOperator'): 7, (6, 'XorOperator'): 10,
        (7, 'Assignment'): 27, (7, 'AtomicFormula'): 21,
        (7, 'BinaryTemporalFormula'): 15, (7, 'Brackets'): 26,
        (7, 'Conjunction'): 12, (7, 'Disjunction'): 9,
        (7, 'FinallyOperator'): 54, (7, 'GloballyOperator'): 56,
        (7, 'NextOperator'): 55, (7, 'NotOperator'): 57,
        (7, 'UnaryFormula'): 18, (7, 'UnaryTemporalOperator'): 22,
        (7, 'Xor'): 8, (8, 'XorOperator'): 10, (9, 'DisjunctionOperator'): 13,
        (10, 'Assignment'): 27, (10, 'AtomicFormula'): 21,
        (10, 'BinaryTemporalFormula'): 15, (10, 'Brackets'): 26,
        (10, 'Conjunction'): 12, (10, 'Disjunction'): 11,
        (10, 'FinallyOperator'): 54, (10, 'GloballyOperator'): 56,
        (10, 'NextOperator'): 55, (10, 'NotOperator'): 57,
        (10, 'UnaryFormula'): 18, (10, 'UnaryTemporalOperator'): 22,
        (11, 'DisjunctionOperator'): 13, (12, 'ConjunctionOperator'): 16,
        (13, 'Assignment'): 27, (13, 'AtomicFormula'): 21,
        (13, 'BinaryTemporalFormula'): 15, (13, 'Brackets'): 26,
        (13, 'Conjunction'): 14, (13, 'FinallyOperator'): 54,
        (13, 'GloballyOperator'): 56, (13, 'NextOperator'): 55,
        (13, 'NotOperator'): 57, (13, 'UnaryFormula'): 18,
        (13, 'UnaryTemporalOperator'): 22, (14, 'ConjunctionOperator'): 16,
        (15, 'BinaryTemporalOperator'): 19, (15, 'UntilOperator'): 30,
        (15, 'WeakUntilOperator'): 31, (16, 'Assignment'): 27,
        (16, 'AtomicFormula'): 21, (16, 'BinaryTemporalFormula'): 17,
        (16, 'Brackets'): 26, (16, 'FinallyOperator'): 54,
        (16, 'GloballyOperator'): 56, (16, 'NextOperator'): 55,
        (16, 'NotOperator'): 57, (16, 'UnaryFormula'): 18,
        (16, 'UnaryTemporalOperator'): 22, (17, 'BinaryTemporalOperator'): 19,
        (17, 'UntilOperator'): 30, (17, 'WeakUntilOperator'): 31,
        (19, 'Assignment'): 27, (19, 'AtomicFormula'): 21,
        (19, 'Brackets'): 26, (19, 'FinallyOperator'): 54,
        (19, 'GloballyOperator'): 56, (19, 'NextOperator'): 55,
        (19, 'NotOperator'): 57, (19, 'UnaryFormula'): 20,
        (19, 'UnaryTemporalOperator'): 22, (22, 'Assignment'): 27,
        (22, 'AtomicFormula'): 21, (22, 'Brackets'): 26,
        (22, 'FinallyOperator'): 54, (22, 'GloballyOperator'): 56,
        (22, 'NextOperator'): 55, (22, 'NotOperator'): 57,
        (22, 'UnaryFormula'): 23, (22, 'UnaryTemporalOperator'): 22,
        (28, 'Assignment'): 27, (28, 'AtomicFormula'): 21,
        (28, 'Biimplication'): 3, (28, 'BinaryTemporalFormula'): 15,
        (28, 'Brackets'): 26, (28, 'Conjunction'): 12, (28, 'Disjunction'): 9,
        (28, 'FinallyOperator'): 54, (28, 'GloballyOperator'): 56,
        (28, 'Implication'): 2, (28, 'NextOperator'): 55,
        (28, 'NotOperator'): 57, (28, 'UnaryFormula'): 18,
        (28, 'UnaryTemporalOperator'): 22, (28, 'Xor'): 6
    }
    _shift = {
        (0, '!'): 66, (0, '('): 28, (0, '<'): 58, (0, 'F'): 60,
        (0, 'FALSE'): 24, (0, 'G'): 65, (0, 'TRUE'): 25, (0, 'X'): 62,
        (0, '['): 63, (0, 'id'): 68, (0, '~'): 67, (1, EOF): 72, (1, '<'): 38,
        (2, '-'): 34, (3, ')'): 29, (3, '<'): 38, (4, '!'): 66, (4, '('): 28,
        (4, '<'): 58, (4, 'F'): 60, (4, 'FALSE'): 24, (4, 'G'): 65,
        (4, 'TRUE'): 25, (4, 'X'): 62, (4, '['): 63, (4, 'id'): 68,
        (4, '~'): 67, (5, '-'): 34, (6, '^'): 53, (7, '!'): 66, (7, '('): 28,
        (7, '<'): 58, (7, 'F'): 60, (7, 'FALSE'): 24, (7, 'G'): 65,
        (7, 'TRUE'): 25, (7, 'X'): 62, (7, '['): 63, (7, 'id'): 68,
        (7, '~'): 67, (8, '^'): 53, (9, '+'): 43, (9, '\\'): 44, (9, '|'): 46,
        (10, '!'): 66, (10, '('): 28, (10, '<'): 58, (10, 'F'): 60,
        (10, 'FALSE'): 24, (10, 'G'): 65, (10, 'TRUE'): 25, (10, 'X'): 62,
        (10, '['): 63, (10, 'id'): 68, (10, '~'): 67, (11, '+'): 43,
        (11, '\\'): 44, (11, '|'): 46, (12, '&'): 51, (12, '*'): 48,
        (12, '/'): 49, (13, '!'): 66, (13, '('): 28, (13, '<'): 58,
        (13, 'F'): 60, (13, 'FALSE'): 24, (13, 'G'): 65, (13, 'TRUE'): 25,
        (13, 'X'): 62, (13, '['): 63, (13, 'id'): 68, (13, '~'): 67,
        (14, '&'): 51, (14, '*'): 48, (14, '/'): 49, (15, 'U'): 32,
        (15, 'W'): 33, (16, '!'): 66, (16, '('): 28, (16, '<'): 58,
        (16, 'F'): 60, (16, 'FALSE'): 24, (16, 'G'): 65, (16, 'TRUE'): 25,
        (16, 'X'): 62, (16, '['): 63, (16, 'id'): 68, (16, '~'): 67,
        (17, 'U'): 32, (17, 'W'): 33, (19, '!'): 66, (19, '('): 28,
        (19, '<'): 58, (19, 'F'): 60, (19, 'FALSE'): 24, (19, 'G'): 65,
        (19, 'TRUE'): 25, (19, 'X'): 62, (19, '['): 63, (19, 'id'): 68,
        (19, '~'): 67, (22, '!'): 66, (22, '('): 28, (22, '<'): 58,
        (22, 'F'): 60, (22, 'FALSE'): 24, (22, 'G'): 65, (22, 'TRUE'): 25,
        (22, 'X'): 62, (22, '['): 63, (22, 'id'): 68, (22, '~'): 67,
        (28, '!'): 66, (28, '('): 28, (28, ')'): 61, (28, '<'): 58,
        (28, 'F'): 60, (28, 'FALSE'): 24, (28, 'G'): 65, (28, 'TRUE'): 25,
        (28, 'X'): 62, (28, '['): 63, (28, 'id'): 68, (28, '~'): 67,
        (34, '-'): 35, (34, '>'): 37, (35, '>'): 36, (38, '-'): 39,
        (39, '-'): 40, (39, '>'): 42, (40, '>'): 41, (44, '/'): 45,
        (46, '|'): 47, (49, '\\'): 50, (51, '&'): 52, (58, '>'): 59,
        (63, ']'): 64, (68, '='): 69, (69, '0'): 70, (69, '1'): 71
    }

    def __init__(self, max_err=None, errcorr_pre=4, errcorr_post=4):
        """Create a new parser instance.

        The constructor arguments are all optional, they control the
        handling of parse errors: `max_err` can be given to bound the
        number of errors reported during one run of the parser.
        `errcorr_pre` controls how many tokens before an invalid token
        the parser considers when trying to repair the input.
        `errcorr_post` controls how far beyond an invalid token the
        parser reads when evaluating the quality of an attempted
        repair.
        """
        self.max_err = max_err
        self.m = errcorr_pre
        self.n = errcorr_post

    @staticmethod
    def leaves(tree):
        """Iterate over the leaves of a parse tree.

        This function can be used to reconstruct the input from a
        parse tree.
        """
        if tree[0] in Parser.terminals:
            yield tree
        else:
            for x in tree[1:]:
                for t in Parser.leaves(x):
                    yield t

    def _parse(self, input, stack, state):
        """Internal function to construct a parse tree.

        'Input' is the input token stream, 'stack' is the inital stack
        and 'state' is the inital state of the automaton.

        Returns a 4-tuple (done, count, state, error).  'done' is a
        boolean indicationg whether parsing is completed, 'count' is
        number of successfully shifted tokens, and 'error' is None on
        success or else the first token which could not be parsed.
        """
        read_next = True
        count = 0
        while state != self._halting_state:
            if read_next:
                try:
                    lookahead = input.next()
                except StopIteration:
                    return (False,count,state,None)
                read_next = False
            token = lookahead[0]

            if (state,token) in self._shift:
                stack.append((state,lookahead))
                state = self._shift[(state,token)]
                read_next = True
                count += 1
            elif (state,token) in self._reduce:
                X,n = self._reduce[(state,token)]
                if n > 0:
                    state = stack[-n][0]
                    tree = (X,) + tuple(s[1] for s in stack[-n:])
                    del stack[-n:]
                else:
                    tree = (X,)
                stack.append((state,tree))
                state = self._goto[(state,X)]
            else:
                return (False,count,state,lookahead)
        return (True,count,state,None)

    def _try_parse(self, input, stack, state):
        count = 0
        while state != self._halting_state and count < len(input):
            token = input[count][0]

            if (state,token) in self._shift:
                stack.append(state)
                state = self._shift[(state,token)]
                count += 1
            elif (state,token) in self._reduce:
                X,n = self._reduce[(state,token)]
                if n > 0:
                    state = stack[-n]
                    del stack[-n:]
                stack.append(state)
                state = self._goto[(state,X)]
            else:
                break
        return count

    def parse(self, input):
        """Parse the tokens from `input` and construct a parse tree.

        `input` must be an interable over tuples.  The first element
        of each tuple must be a terminal symbol of the grammar which
        is used for parsing.  All other element of the tuple are just
        copied into the constructed parse tree.

        If `input` is invalid, a ParseErrors exception is raised.
        Otherwise the function returns the parse tree.
        """
        errors = []
        input = chain(input, [(self.EOF,)])
        stack = []
        state = 0
        while True:
            done,_,state,lookahead = self._parse(input, stack, state)
            if done:
                break

            expect = [ t for s,t in self._reduce.keys()+self._shift.keys()
                       if s == state ]
            errors.append((lookahead, expect))
            if self.max_err is not None and len(errors) >= self.max_err:
                raise self.ParseErrors(errors, None)

            queue = []
            def split_input(m, stack, lookahead, input, queue):
                for s in stack:
                    for t in self.leaves(s[1]):
                        queue.append(t)
                        if len(queue) > m:
                            yield queue.pop(0)
                queue.append(lookahead)
            in2 = split_input(self.m, stack, lookahead, input, queue)
            stack = []
            done,_,state,lookahead = self._parse(in2, stack, 0)
            m = len(queue)
            for i in range(0, self.n):
                try:
                    queue.append(input.next())
                except StopIteration:
                    break

            def vary_queue(queue, m):
                for i in range(m-1, -1, -1):
                    for t in self.terminals:
                        yield queue[:i]+[(t,)]+queue[i:]
                    if queue[i][0] == self.EOF:
                        continue
                    for t in self.terminals:
                        if t == queue[i]:
                            continue
                        yield queue[:i]+[(t,)]+queue[i+1:]
                    yield queue[:i]+queue[i+1:]
            best_val = len(queue)-m+1
            best_queue = queue
            for q2 in vary_queue(queue, m):
                pos = self._try_parse(q2, [ s[0] for s in stack ], state)
                val = len(q2) - pos
                if val < best_val:
                    best_val = val
                    best_queue = q2
                    if val == len(q2):
                        break
            if best_val >= len(queue)-m+1:
                raise self.ParseErrors(errors, None)
            input = chain(best_queue, input)

        tree = stack[0][1]
        if errors:
            raise self.ParseErrors(errors, tree)
        return tree
